/**
 * Copyright (C) 2017 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};


// 标题部分
RE.article_title = document.getElementById('article_title');

// 内容部分
RE.editor = document.getElementById('editor');

//document.addEventListener("selectionchange", function() {RE.backuprange(); });

//RE.article_title.onfocus = function(){
//    window.location.href = "re-state-title://" ;
//}

RE.titleCallback = function() {
    window.location.href = "re-title-callback://" + encodeURI(RE.getEditorTitle());
}

RE.getEditorTitle = function() {
    return RE.article_title.value;
}

RE.setEditorTitle = function(title) {
    RE.article_title.value = decodeURIComponent(title.replace(/\+/g, '%20'));
}

// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURI(RE.getHtml());
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}

RE.getText = function() {
//    return RE.editor.innerText;
    var text = RE.editor.innerText;
    android.getText(text);
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
}

RE.setBullets = function() {
    document.execCommand('insertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('insertOrderedList', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+ heading +'>');
}

RE.setIndent = function() {
 //------过滤判断是否有缩进
    var tag = RE.currentNodeIsRetract();
    if(!tag){
        document.execCommand('indent', false, null);
    }
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

//判断当前标签是否缩进
RE.currentNodeIsRetract = function (){
    let sel = window.getSelection();
    var currentBody = sel.anchorNode;
    //------过滤判断是否有缩进
    var tag = false;
    while(!tag && currentBody != null ){
        var tagName = currentBody.nodeName;
        if(tagName.toLowerCase() == 'blockquote'){
            tag = true;
        }else{
            if(tagName.toLowerCase() == 'div' && $(currentBody).attr('id') == 'editor'){
                break;
            }
            currentBody = currentBody.parentNode;
        }
    }

    if(tag){
        android.currentNodeIsRetract(true);
    }else{
        android.currentNodeIsRetract(false);
    }

    return tag;
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}

RE.insertImage = function(url, alt) {
    var html = '<img src="' + url + '" alt="' + alt + '" />';
    RE.insertHTML(html);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}

RE.enabledEditingItems = function() {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    if (document.queryCommandState('selectAll')) {
            items.push('selectAll');
        }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }


//    android.showKeyBoards( items.join(','));

    window.location.href = "re-state://" + encodeURI(items.join(','));
}

RE.locationFromId = function(id){
    window.location.href = '#'+id;
}

RE.setDivId = function(){
    var array = [];
    $('div').each(function (i, ele) {
        var divId = $(ele).attr('id');
        if(divId === undefined || divId == null || divId == ''){
            $(this).attr('id','divContent');
            array.push({id: $(ele).attr('id'), text: $(ele).text()});
        }
    });
    if(array.length > 0){
        RE.callback();
    }
}
RE.setBodyStyle = function(){
    var current_selection = $(RE.getSelectedNode());
        var t = current_selection.prop("tagName").toLowerCase();
        var is_paragraph = (t == 'div');
//        if (is_paragraph) {
//            var c = current_selection.html();
//            current_selection.replaceWith(c);
//        } else {
//            document.execCommand('formatBlock', false, '<div>');
//        }
        if (!is_paragraph) {
            document.execCommand('formatBlock', false, '<div>');
        }
        RE.setDivId();
}

RE.getSelectedNode = function() {
    var node,selection;
    if (window.getSelection) {
        selection = getSelection();
        node = selection.anchorNode;
    }
    if (!node && document.selection) {
        selection = document.selection
        var range = selection.getRangeAt ? selection.getRangeAt(0) : selection.createRange();
        node = range.commonAncestorContainer ? range.commonAncestorContainer :
        range.parentElement ? range.parentElement() : range.item(0);
    }
    if (node) {
        return (node.nodeName == "#text" ? node.parentNode : node);
    }
};

RE.getDirectory = function() {
    var str = RE.getDirectoryArray();
    android.getDirectoryString(str);
}

RE.getDirectoryListToNative = function() {
    var str = RE.getDirectoryArray();
    android.getDirectoryList(str);
}


RE.getDirectoryArray = function(){
var array = [];
    $('h1,h2,h3').each(function (i, ele) {
        var tagId = $(ele).attr('id');
        if(tagId === undefined || tagId == null ){
            $(this).attr('id',$(this).index());
        }
        var tagName = $(this)[0].tagName;
        array.push({id: $(ele).attr('id'), text: $(ele).text(), tag: tagName});
    });

     var str = "";
        for(j = 0,len = array.length; j < len; j++) {
            if(typeof array[j].text != "undefined" && array[j].text != null && array[j].text != ""){
                 str = str + array[j].id + "-body-title-" + array[j].text + "-body-title-" + array[j].tag + ";";
            }
        }
    return str;
}

RE.focus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();

}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}

window.onload = function () {
    var box = RE.editor;
    box.addEventListener('click', RE.getTitleAndBody);
    box.addEventListener('input', RE.getTitleAndBody);
    /*box.addEventListener('click', function(e){
        setTimeout("RE.getTitleAndBody()","300");
    });
    box.addEventListener('input', function(e){
            setTimeout("RE.getTitleAndBody()","300");
        });*/
}

//获取标题和正文的方法
RE.getTitleAndBody = function(){

    RE.currentNodeIsRetract();
    let sel = window.getSelection();
    let currentNode = sel.anchorNode;
    let currentBody = sel.anchorNode;
    if (currentNode.nodeType == 3) { //Element或者Attr中实际的文字
        currentBody = currentNode = currentNode.parentNode; //parentNode:返回指定的节点在DOM树中的父节点
    }
    let currentTag = $(currentNode)[0].tagName;
    let content = $(currentNode).text();
    var text = $(currentNode).text();

    //当页面删除干净后，重新输入会不生成标签解决办法
    if (currentTag.toLocaleUpperCase() == 'DIV' && (text != '' || text != undefined) && $(currentNode).attr('id') == 'editor'){
            $(currentNode).empty();
            var div = document.createElement("div");
            div.setAttribute('id', 'divContent');
            div.innerHTML = text;
            currentNode.appendChild(div);
            RE.callback();
            RE.focus();
    }

    if (currentTag.substring(0,1).toLocaleUpperCase() == 'H'){
        if(content == '' || content == undefined){
            android.getBodyAndTitle("abstract");
        }else{
            android.getBodyAndTitle("false");
        }
        return;
    }

     $('[id=divContent]').each((idx, node) => {
            if (node.innerHTML == "<span><br></span>"){
                $(node).empty();
                node.appendChild(document.createElement('br'))
            }else if(node.innerHTML == "<blockquote><br></blockquote>"){
                $(node).empty();
                node.appendChild(document.createElement('br'))
            }
         });

    //------获取光标所在的标题
    let title = '';
    if(currentTag.substring(0,1).toLocaleUpperCase() == 'S'){
        currentNode = currentNode.parentNode;
        currentTag = $(currentNode)[0].tagName;
    }

    if (currentTag.substring(0,1).toLocaleUpperCase() != 'H') {
        title = $(currentNode).prevAll('h1,h2,h3').eq(0).text();
    }

    //------过滤判断是否有缩进
    var tag1 = false;
    while(!tag1 && currentBody != undefined && title == ''){
        var tagName = $(currentBody)[0].tagName;
        if(tagName.toLowerCase() == 'blockquote'){
            if(currentBody.parentNode.nodeName.toLowerCase() == 'div' && $(currentBody.parentNode).attr('id') == 'divContent'){
                currentBody = currentBody.parentNode;
            }
            title = $(currentBody).prevAll('h1,h2,h3').eq(0).text();
            tag1 = true;
        }else{
            if(tagName.toLowerCase() == 'div' && $(currentBody).attr('id') == 'editor'){
                tag1 = true;
            }
            currentBody = currentBody.parentNode;
        }
    }
       var content2 = RE.getFocusText();
       android.getBodyAndTitle(content2 + "-body-title-"+ title);
//       android.getBodyAndTitle(content2);
   }

   RE.getFocusText = function() {
       let sel = window.getSelection();
       let currentNode = sel.anchorNode;
       let currentPos = sel.getRangeAt(0).startOffset;
       if (!RE.isContinueElement(currentNode)) {
           return ""
       }
       var tmp = currentNode;
       let content = $(sel.anchorNode).text().substring(0, currentPos)
       if ($(tmp).attr('id') == 'editor') {
           return content
       }
       let count = 0;
       while(tmp != null && $(tmp).attr('id') != 'editor'){
           if (count > 20){
               break
           }
           let res = RE.getParentText(tmp)
           content = (res[0] + content)
           if (!res[1]) {
               break
           }
           tmp = tmp.parentElement
       }
       return content
   }

   RE.getParentText = function(element) {
       let content = ""
       tmp = element.previousSibling
       var count = 0
        while(tmp != null && RE.isContinueElement(tmp)){
               if (count > 20){
                   break
                }
               if ($(tmp).is(':has(h1)') || $(tmp).is(':has(h2)') || $(tmp).is(':has(h3)')) {
                   return [content, false]
               }
               var str = $(tmp).text()
               content = (str + content)
               tmp = tmp.previousSibling;
        }
        if (tmp == null) {
             return [content, true]
        }
        return [content, false]
   }

   RE.notNull = function (obj) {
       if (typeof(obj) != "undefined" && obj != null) {
           return true
       }
       return false
   }

   RE.isElement = function (element, name) {
       if (RE.notNull(element)) {
           return name == element.tagName.toLocaleUpperCase()
       }
       return false
   }

   RE.isContinueElement = function(element) {
       if (!RE.notNull(element)) {
           return false
       }
       return element.nodeType == 3 || RE.isElement(element, "DIV")|| RE.isElement(element, "BLOCKQUOTE") || RE.isElement(element, "SPAN") || RE.isElement(element, "FONT") || RE.isElement(element, "BR")
   }

RE.insertText = function(content) {
//    RE.restorerange();
//    content = decodeURIComponent(content.replace(/\+/g, '%20'))
//    RE.backuprange();
    content = decodeURIComponent(content);
    document.execCommand('insertHTML', false, content);
     RE.callback();
}

RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.clearBackTxt = function(){
    var target=document.getElementById("back-text");
    target.style.display="none";

}
RE.showBackTxt = function(){
    var target=document.getElementById("back-text");
    target.style.display="block";
}

// Event Listeners
RE.editor.addEventListener("input", function(e){
    RE.callback();
    android.isTitleOrEditor("editor");
});
RE.article_title.addEventListener("input",function(e){
    RE.titleCallback();
    android.isTitleOrEditor("title");
});
RE.article_title.addEventListener("click",function(e){
    android.isTitleOrEditor("title");
});
RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        RE.enabledEditingItems();
    }
});
RE.editor.addEventListener("click", RE.enabledEditingItems);
RE.editor.addEventListener("click", function(e){
    android.isTitleOrEditor("editor");
    RE.removeAttr();
});

RE.removeAttr = function(){
    $("span").removeAttr('style');
}

RE.editor.addEventListener("input", function(e){
    android.recommendListener();
    var bodyHeight = document.body.scrollHeight;
    var keyBoardHeight = android.getKeyBoardHeight();
    var height = RE.getCaretYPosition() + 50;
    var deffHeight = bodyHeight - height;
    if(deffHeight < keyBoardHeight){
        $('#editor').height($('#editor').height() + keyBoardHeight + 50);
    }
    android.scrollWebViewToShowLine(height);

});

//自动滚动处理
RE.getCaretYPosition = function() {
    var sel = window.getSelection();
    // Next line is comented to prevent deselecting selection. It looks like work but if there are any issues will appear then uconmment it as well as code above.
    //sel.collapseToStart();
    var range = sel.getRangeAt(0);
    var span = document.createElement('span');// something happening here preventing selection of elements
    range.collapse(false);
    range.insertNode(span);
    var topPosition = span.offsetTop;
    var spanParent = span.parentNode;
    spanParent.removeChild(span);
    spanParent.normalize();
    return topPosition;
}

RE.autoScroll = function(topY){
    window.scrollTo(0,topY);
}

RE.didClickDownBtn=function(){
    android.showTitleList();
//    window.location.href = "re-didclickdownBtn://";
}

